/*!
	CNormalListenerConnection

	IPv4用の接続管理クラス
*/

#pragma once
#include "IClientConnection.h"
#include "ProtocolSocket.h"

/*!
	ノーマルリスナ　クライアントインタフェース

	通常のHTTPの通信クラス
	throw CConnectionErrorException
	throw CServerResponse
*/
class CNormalListenerConnection : public IClientConnection
{
public:
	//!	コンストラクタ
	CNormalListenerConnection(SOCKET sock, int timeout);

	//!	デストラクタ
	virtual ~CNormalListenerConnection();

protected:
	//////////////////////////////////////////////////////////////////////////////////////////////
	//	IClientConnection
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	初期化
	virtual void AttacheToThread(IServerToolIIPtr serverTool, IConnectionThreadStatusIIPtr threadStatus);

	//!	初期化
	virtual void Close();


	//!	クライアント情報の取得
	virtual void GetClientInfo(CContextClientInfo info);

	//!	次の接続を待つ
	virtual int WaitNextConnection(int waitTime);

	//!	接続中か取得する(内部でIConnectionThreadStatusIIPtr::IsConnectingの使用厳禁)
	virtual int IsConnecting();


	//!	ヘッダを受信(throw)
	virtual void RecvRequestHeader(CString &requestHeader);

	//!	ボディを受信(throw)
	virtual int RecvRequestBody(CBinaryData &body, int blockSize);

	//!	受信処理完了
	virtual void EndRecvRequest() {};


	//!	ヘッダを送信(throw)
	virtual void SendResponseHeader(CString &responseHeader);

	//!	ボディを送信(throw)
	virtual void SendResponseBody(CBinaryData &body);

	//!	送信処理完了
	virtual void EndSendResponse() {};
	

	/////////////////////////////////////////////////////////////////////
	//	メンバ変数
	/////////////////////////////////////////////////////////////////////
	//!	ソケット
	CProtocolSocket	m_socket;
	
	//!	親スレッドの状態
	IConnectionThreadStatusIIPtr	m_threadStatus;
};
